WRITING EXECUTABLE STATEMENTS
--------------------------------

1) DELIMITERS: +, -, *, / , = , @, ;
------------------------------------

2) COMPOUND SYMBOLS: <>, !=, || , --, /*, */, :=
------------------------------------------------

3) IDENTIFIERS: SOME RULES
---------------------------

INVALID EXAMPLES:
-----------------

dots&dashes
debit-amount
on/off
user id


4) COMMENTING CODE: 
-------------------

SINGLE LINE: --
MULTIPLE-LINE: /* AND */

EXAMPLE:

DECLARE
  X INT;  -- SINGLE LINE COMMENT
BEGIN
  /* MULTIPLE
     LINE
     COMMENT
  */
  X := 1;
END;

-- ALL THE SINGLE-ROW FUNCTIONS CAN BE USED IN A PL/SQL BLOCK. EXAMPLE:

DECLARE
  v_name varchar2(10);
BEGIN
  v_name := UPPER('teste');
  DBMS_OUTPUT.PUT_LINE('Value: ' || v_name);
END;


NOTE: DECODE AND GROUP FUNCTIONS ARE NOT AVAILABLE IN PROCEDURAL STATEMENTS!
------------------------------------------------------------------------------

5) NESTED BLOCKS AND SCOPE
---------------------------

DECLARE 
  x INTEGER := 10;
BEGIN
 
  DECLARE
    y INTEGER;
  BEGIN
    y := 20;
    
    DBMS_OUTPUT.PUT_LINE('Value of x:' || TO_CHAR(x));
    DBMS_OUTPUT.PUT_LINE('Value of y:' || TO_CHAR(y));
  END;
END;


DECLARE 
  x INTEGER := 10;
BEGIN
 
  DECLARE
    y INTEGER;
  BEGIN
    y := 20;
    
    DBMS_OUTPUT.PUT_LINE('Value of x:' || TO_CHAR(x));

  END;

  DBMS_OUTPUT.PUT_LINE('Value of y:' || TO_CHAR(y));
END;

QUALIFY AND IDENTIFIER BY USING BLOCK LABEL PREFIX:
-----------------------------------------------------

<<outer>>
DECLARE 
  x INTEGER;
BEGIN
  x := 10;
  
  DECLARE
    y INTEGER;
  BEGIN
  
    y := 20;
    
    DBMS_OUTPUT.PUT_LINE('Value ot x:' || TO_CHAR(outer.x));
    DBMS_OUTPUT.PUT_LINE('Value ot y:' || TO_CHAR(y));
    
  END;

END;

6) OPERATORS ARE (ALMOST) THE SAME IN SQL AND PL/SQL
------------------------------------------------------

OPERATORS: **, +, -, *, /, ||
           =, <, >, <= , >=, <> , !=, 
           IS NULL, LIKE, BETWEEN, IN
           NOT, AND , OR
           
7) ADVICE: USE CODE CONVENTIONS!
--------------------------------